#!/bin/bash

export LANGUAGE=zh_CN.UTF-8
export LC_ALL=zh_CN.UTF-8
export LANG=zh_CN.UTF-8

PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:~/bin
export PATH
LANG=en_US.UTF-8
set -e

# Get Infomation for kserver, which is devices discovery services
Get_Info(){
    #SITE_DIR=$(sed -n -r 's/\sroot (.*);/\1/p' /etc/nginx/sites-enabled/default | tr -d ' ')
    SITE_DIR=$(sed -n -r 's/^\s*root\s+(.*);$/\1/p' /etc/nginx/sites-enabled/default | tr -d ' ')
    SITE_VERS=$(sed -n "s/.*'\\(.*\\)'.*/\\1/p" ${SITE_DIR}/config/version.php | tr '\n' '.')
    # D_SN=$(cat /sys/devices/virtual/dmi/id/product_serial | cut -d '-' -f1)
    IP_ADDR=$(ip -o route get 255.0 2>/dev/null | sed -e 's/.*src \([^ ]*\) .*/\1/')
    SITE_PORT=$(perl -lne 'print $1 if /\s+listen\s+(\w+)/' /etc/nginx/sites-enabled/default | head -1)
    HOST_NAME=$(hostname -s)

    echo "{
    \"hostName\": \"${HOST_NAME}\",
    \"installed\": \"$([ -f ${SITE_INSTALLED} ] && echo 'true' || echo 'false')\",
    \"ip\": \"${IP_ADDR}\",
    \"mac\":\"$(cat /sys/class/net/$(ip -o route get 255.0 | awk '{print $5}')/address)\",
    \"version\": \"${SITE_VERS}\",
    \"SN\": \"${D_SN}\",
    \"port\": \"${SITE_PORT}\"
}"
}

case "$1" in
    'getInfo')
        Get_Info
        ;;
    *)
        echo "input error"
        ;;
esac

